/******************************************************************************
 *	File	:	PdoDefine.h
 *	Version :	1.52
 *	Date	:	2021/11/23
 *	Author	:	XFORCE
 *
 *
 *	Define slave device PDO data structure
 *
 *	You can configure the PDO structure you wanted,
 *	or you can just use the default PDO structure.
 *	No matter what, the example program need to know.
 *
 *
 * @copyright (C) 2020 NEXTW TECHNOLOGY CO., LTD.. All rights reserved.
 *
 ******************************************************************************/
#ifndef _ECM_USR_PDO_DEFINE_H_
#define _ECM_USR_PDO_DEFINE_H_

#define TEST_DRV_CNT			2
#define TEST_IO_CNT				1
#define COUPLER_CNT				0
#define TEST_SLV_CNT			(TEST_DRV_CNT+COUPLER_CNT+TEST_IO_CNT)

#define TEST_CTL_WORD_OFFSET	0
#define TEST_STA_WORD_OFFSET	0

#define TEST_MODEOP	6 //HOME Mode

#if (TEST_MODEOP == 4)
#define TARGET_TYPE		int16_t
#elif (TEST_MODEOP == 10)
#define TARGET_TYPE		int16_t
#else
#define TARGET_TYPE		int32_t
#endif

typedef struct __attribute__((__packed__)) _axis_rxpdo_st_def_t
{
	uint16_t		u16CtlWord;	//	0x6x40 - Control word
	TARGET_TYPE		Target;		//	0x6x7A - Target position
								//	0x6xFF - Target velocity
								//	0x6x71 - Target torque
}AXIS_RXPDO_ST_DEF_T;
typedef struct __attribute__((__packed__)) _axis_txpdo_st_def_t
{
	uint16_t		u16StaWord;	//	0x6x41 - Status word
	TARGET_TYPE		Actual;		//	0x6x64 - Actual position
								//	0x6x6C - Actual velocity
								//	0x6x77 - Actual torque
}AXIS_TXPDO_ST_DEF_T;

typedef struct __attribute__((__packed__)) _io_rxpdo_st_def_t
{
	uint16_t DO;
}IO_RXPDO_ST_DEF_T;

typedef struct __attribute__((__packed__)) _io_txpdo_st_def_t
{
	uint16_t DI;
}IO_TXPDO_ST_DEF_T;

typedef struct __attribute__((__packed__)) _rxpdo_st_def_t
{
	AXIS_RXPDO_ST_DEF_T Axis[TEST_DRV_CNT];
#if (TEST_IO_CNT > 0)
	IO_RXPDO_ST_DEF_T Io[TEST_IO_CNT];
#endif
}RXPDO_ST_DEF_T;

typedef struct __attribute__((__packed__)) _txpdo_st_def_t
{
	AXIS_TXPDO_ST_DEF_T Axis[TEST_DRV_CNT];
#if (TEST_IO_CNT > 0)
	IO_TXPDO_ST_DEF_T Io[TEST_IO_CNT];
#endif
}TXPDO_ST_DEF_T;
#endif
