#include <unistd.h>
#include "EcmUsrDriver.h"
#include "rta.h"
#define B_ML		0
#define B_PL		4
#define B_SHIFT		8
#define B_HIGH		12
#define B_LOW		16
#define B_ONE		20
#define B_ZERO		24
#define B_FLAG		28
int ECM_RTA_ENC_COMPARE(int32_t n32Axis, int32_t nML, int32_t nPL, int32_t nShift,
						uint32_t u32EioPdoOffset)
{
	int i=0;
	int32_t nRet=0;
	int32_t n32RtaBuf[8] = 
	{
		nML,
		nPL,
		nShift,
		0x55555555,//Output HIGH
		0,//Outpuy LOW
		1,//1(Constant)
		0,//0(Constant)
		0
	};
	RTA_RULE RtaCode[20];
	memset(RtaCode, 0 ,sizeof(RtaCode));
	i=0;
	//	CONDITION = 0
	RtaCode[i].u8Operator = RTA_OPCODE_CONDI_ASSIGN;
	RtaCode[i].u8Condition = 0;
	i++;
	/*	
		if(nPos < nML){
			CONDITION |= 1;
		}
	*/
	RtaCode[i].u8Operator = RTA_OPCODE_CONDI_LESS;
	RtaCode[i].u8Condition = 1;
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_TXPDO | RTA_DATA_SIZE4 | ((6*n32Axis)+2));
	RtaCode[i].u16Operant[1] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_ML);
	i++;
	/*	
		if(nPos > nPL){
			CONDITION |= 2;
		}
	*/
	RtaCode[i].u8Operator = RTA_OPCODE_CONDI_MORE;
	RtaCode[i].u8Condition = 2;
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_TXPDO | RTA_DATA_SIZE4 | ((6*n32Axis)+2));
	RtaCode[i].u16Operant[1] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_PL);
	i++;
	/*
		if(CONDITION & 0x03){
			Output = Low;		
		}else{
			Output = High;
		}
	*/
	RtaCode[i].u8Operator = (RTA_OPCODE_IF_ELSE | RTA_OPCODE_ASSIGN);
	RtaCode[i].u8Condition = (RTA_CONDI_AND_MASK | 0x03) ;
	RtaCode[i].u16Result = (RTA_DATA_SRC_RXPDO | RTA_DATA_SIZE2 | u32EioPdoOffset);
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE2 | B_LOW);
	RtaCode[i].u16Operant[1] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE2 | B_HIGH);
	i++;
	/*
		if(!(CONDITION & 0x03)){
			nDone = 1;
		}
	*/
	RtaCode[i].u8Operator = (RTA_OPCODE_IF_NOT | RTA_OPCODE_ASSIGN);
	RtaCode[i].u8Condition = (RTA_CONDI_AND_MASK | 0x03) ;
	RtaCode[i].u16Result = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_FLAG);
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE2 | B_ONE);
	i++;
	/*	
		if(nDone == 1){
			CONDITION |= 4;
		}
	*/
	RtaCode[i].u8Operator = RTA_OPCODE_CONDI_EQUAL;
	RtaCode[i].u8Condition = 0x04;
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_FLAG);
	RtaCode[i].u16Operant[1] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_ONE);
	i++;
	/*
		if(CONDITION == 0x06){
			nML += nShift;
		}
	*/
	RtaCode[i].u8Operator = (RTA_OPCODE_IF | RTA_OPCODE_ADD);
	RtaCode[i].u8Condition = (RTA_CONDI_AND_EQUEL | 0x06);
	RtaCode[i].u16Result = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_ML);
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_ML);
	RtaCode[i].u16Operant[1] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_SHIFT);
	i++;
	/*
		if(CONDITION == 0x06){
			nPL += nShift;
		}
	*/
	RtaCode[i].u8Operator = (RTA_OPCODE_IF | RTA_OPCODE_ADD);
	RtaCode[i].u8Condition = (RTA_CONDI_AND_EQUEL | 0x06);
	RtaCode[i].u16Result = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_PL);	
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_PL);
	RtaCode[i].u16Operant[1] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_SHIFT);
	i++;
	/*
		if(CONDITION == 0x06){
			nDone = 0;
		}
	*/
	RtaCode[i].u8Operator = (RTA_OPCODE_IF | RTA_OPCODE_ASSIGN);
	RtaCode[i].u8Condition = (RTA_CONDI_AND_EQUEL | 0x06) ;
	RtaCode[i].u16Result = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_FLAG);
	RtaCode[i].u16Operant[0] = (RTA_DATA_SRC_BUF | RTA_DATA_SIZE4 | B_ZERO);
	i++;
	ECM_RtaSetEnable(0);
	usleep(2000);//2ms
	nRet=ECM_RtaInit(i, sizeof(n32RtaBuf));
	printf("ECM_RtaInit(%d) %d\n",i,nRet);
	nRet=ECM_RtaSetBuf(0, sizeof(n32RtaBuf), (uint8_t *)n32RtaBuf);
	printf("ECM_RtaSetBuf %d\n",nRet);
	nRet=ECM_RtaSetRule(0, i, RtaCode);
	printf("ECM_RtaSetRule(%d) %d\n",i,nRet);
	ECM_RtaSetEnable(1);
	return 0;							
}